QwtPlot(3)

NAME
QwtPlot - A 2-D plotting widget.

SYNOPSIS

#include <qwt_plot.h>

Inherits QFrame, and QwtPlotDict.

  Public Types
enum LegendPosition { LeftLegend, RightLegend, BottomLegend, TopLegend }
enum Axis { yLeft = QwtAxis::YLeft, yRight = QwtAxis::YRight, xBottom = QwtAxis::XBottom, xTop = QwtAxis::XTop, axisCnt = QwtAxis::AxisPositions }

  Public Slots
virtual void replot ()
Redraw the plot.
void autoRefresh ()
Replots the plot if autoReplot() is true.

  Signals
void itemAttached (QwtPlotItem *plotItem, bool on)
void legendDataChanged (const QVariant &itemInfo, const QList< QwtLegendData > &data)

  Public Member Functions
QwtPlot (QWidget *=NULL)
Constructor.
QwtPlot (const QwtText &title, QWidget *=NULL)
Constructor.
virtual ~QwtPlot ()
Destructor.
void setAutoReplot (bool=true)
Set or reset the autoReplot option.
bool autoReplot () const
void setPlotLayout (QwtPlotLayout *)
Assign a new plot layout.
QwtPlotLayout * plotLayout ()
const QwtPlotLayout * plotLayout () const
void setTitle (const QString &)
void setTitle (const QwtText &)
QwtText title () const
QwtTextLabel * titleLabel ()
const QwtTextLabel * titleLabel () const
void setFooter (const QString &)
void setFooter (const QwtText &)
QwtText footer () const
QwtTextLabel * footerLabel ()
const QwtTextLabel * footerLabel () const
void setCanvas (QWidget *)
Set the drawing canvas of the plot widget.
QWidget * canvas ()
const QWidget * canvas () const
void setCanvasBackground (const QBrush &)
Change the background of the plotting area.
QBrush canvasBackground () const
virtual QwtScaleMap canvasMap (QwtAxisId) const
double invTransform (QwtAxisId, double pos) const
double transform (QwtAxisId, double value) const
Transform a value into a coordinate in the plotting region.
bool isAxisValid (QwtAxisId) const
void setAxisVisible (QwtAxisId, bool on=true)
Hide or show a specified axis.
bool isAxisVisible (QwtAxisId) const
QwtScaleEngine * axisScaleEngine (QwtAxisId)
const QwtScaleEngine * axisScaleEngine (QwtAxisId) const
void setAxisScaleEngine (QwtAxisId, QwtScaleEngine *)
void setAxisAutoScale (QwtAxisId, bool on=true)
Enable autoscaling for a specified axis.
bool axisAutoScale (QwtAxisId) const
void setAxisFont (QwtAxisId, const QFont &)
Change the font of an axis.
QFont axisFont (QwtAxisId) const
void setAxisScale (QwtAxisId, double min, double max, double stepSize=0)
Disable autoscaling and specify a fixed scale for a selected axis.
void setAxisScaleDiv (QwtAxisId, const QwtScaleDiv &)
Disable autoscaling and specify a fixed scale for a selected axis.
void setAxisScaleDraw (QwtAxisId, QwtScaleDraw *)
Set a scale draw.
double axisStepSize (QwtAxisId) const
Return the step size parameter that has been set in setAxisScale.
QwtInterval axisInterval (QwtAxisId) const
Return the current interval of the specified axis.
const QwtScaleDiv & axisScaleDiv (QwtAxisId) const
Return the scale division of a specified axis.
const QwtScaleDraw * axisScaleDraw (QwtAxisId) const
Return the scale draw of a specified axis.
QwtScaleDraw * axisScaleDraw (QwtAxisId)
Return the scale draw of a specified axis.
const QwtScaleWidget * axisWidget (QwtAxisId) const
QwtScaleWidget * axisWidget (QwtAxisId)
void setAxisLabelAlignment (QwtAxisId, Qt::Alignment)
void setAxisLabelRotation (QwtAxisId, double rotation)
void setAxisTitle (QwtAxisId, const QString &)
Change the title of a specified axis.
void setAxisTitle (QwtAxisId, const QwtText &)
Change the title of a specified axis.
QwtText axisTitle (QwtAxisId) const
void setAxisMaxMinor (QwtAxisId, int maxMinor)
int axisMaxMinor (QwtAxisId) const
void setAxisMaxMajor (QwtAxisId, int maxMajor)
int axisMaxMajor (QwtAxisId) const
void insertLegend (QwtAbstractLegend *, LegendPosition=QwtPlot::RightLegend, double ratio=-1.0)
Insert a legend.
QwtAbstractLegend * legend ()
const QwtAbstractLegend * legend () const
void updateLegend ()
void updateLegend (const QwtPlotItem *)
virtual QSize sizeHint () const override
virtual QSize minimumSizeHint () const override
Return a minimum size hint.
virtual void updateLayout ()
Adjust plot content to its current size.
virtual void drawCanvas (QPainter *)
void updateAxes ()
Rebuild the axes scales.
void updateCanvasMargins ()
Update the canvas margins.
virtual void getCanvasMarginsHint (const QwtScaleMap maps[], const QRectF &canvasRect, double &left, double &top, double &right, double &bottom) const
Calculate the canvas margins.
virtual bool event (QEvent *) override
Adds handling of layout requests.
virtual bool eventFilter (QObject *, QEvent *) override
Event filter.
virtual void drawItems (QPainter *, const QRectF &, const QwtScaleMap maps[QwtAxis::AxisPositions]) const
virtual QVariant itemToInfo (QwtPlotItem *) const
Build an information, that can be used to identify a plot item on the legend.
virtual QwtPlotItem * infoToItem (const QVariant &) const
Identify the plot item according to an item info object, that has bee generated from itemToInfo().
void enableAxis (int axisId, bool on=true)
bool axisEnabled (int axisId) const

  Protected Member Functions
virtual void resizeEvent (QResizeEvent *) override

Detailed Description

A 2-D plotting widget. QwtPlot is a widget for plotting two-dimensional graphs. An unlimited number of plot items can be displayed on its canvas. Plot items might be curves (QwtPlotCurve), markers (QwtPlotMarker), the grid (QwtPlotGrid), or anything else derived from QwtPlotItem. A plot can have up to four axes, with each plot item attached to an x- and a y axis. The scales at the axes can be explicitly set (QwtScaleDiv), or are calculated from the plot items, using algorithms (QwtScaleEngine) which can be configured separately for each axis.

The simpleplot example is a good starting point to see how to set up a plot widget.

Example
    The following example shows (schematically) the most simple way to use QwtPlot. By default, only the left and bottom axes are visible and their scales are computed automatically.

    #include <qwt_plot.h>
    #include <qwt_plot_curve.h>
         QwtPlot *myPlot = new QwtPlot( "Two Curves", parent );
         // add curves
         QwtPlotCurve *curve1 = new QwtPlotCurve( "Curve 1" );
         QwtPlotCurve *curve2 = new QwtPlotCurve( "Curve 2" );
         // connect or copy the data to the curves
         curve1->setData( ... );
         curve2->setData( ... );
         curve1->attach( myPlot );
         curve2->attach( myPlot );
         // finally, refresh the plot
         myPlot->replot();

Definition at line 78 of file qwt_plot.h.

Member Enumeration Documentation

  enum QwtPlot::LegendPosition
Position of the legend, relative to the canvas.

See also
    insertLegend()

Enumerator

LeftLegend
    The legend will be left from the QwtAxis::YLeft axis.

RightLegend
    The legend will be right from the QwtAxis::YRight axis.

BottomLegend
    The legend will be below the footer.

TopLegend
    The legend will be above the title.

Definition at line 93 of file qwt_plot.h.

Constructor & Destructor Documentation

  QwtPlot::QwtPlot (QWidget * parent = NULL) [explicit]

Constructor.

Parameters
    parent Parent widget

Definition at line 103 of file qwt_plot.cpp.

  QwtPlot::QwtPlot (const QwtText & title, QWidget * parent = NULL) [explicit]

Constructor.

Parameters
    title Title text
    parent Parent widget

Definition at line 114 of file qwt_plot.cpp.

Member Function Documentation

  bool QwtPlot::autoReplot () const

Returns
    true if the autoReplot option is set.

See also
    setAutoReplot()

Definition at line 319 of file qwt_plot.cpp.

  bool QwtPlot::axisAutoScale (QwtAxisId axisId) const

Returns
    True, if autoscaling is enabled

Parameters
    axisId Axis

Definition at line 213 of file qwt_plot_axis.cpp.

  QFont QwtPlot::axisFont (QwtAxisId axisId) const

Returns
    The font of the scale labels for a specified axis

Parameters
    axisId Axis

Definition at line 237 of file qwt_plot_axis.cpp.

  QwtInterval QwtPlot::axisInterval (QwtAxisId axisId) const

Return the current interval of the specified axis. This is only a convenience function for axisScaleDiv( axisId )->interval();

Parameters
    axisId Axis

Returns
    Scale interval

See also
    QwtScaleDiv, axisScaleDiv()

Definition at line 344 of file qwt_plot_axis.cpp.

  int QwtPlot::axisMaxMajor (QwtAxisId axisId) const

Returns
    The maximum number of major ticks for a specified axis

Parameters
    axisId Axis

See also
    setAxisMaxMajor(), QwtScaleEngine::divideScale()

Definition at line 251 of file qwt_plot_axis.cpp.

  int QwtPlot::axisMaxMinor (QwtAxisId axisId) const

Returns
    the maximum number of minor ticks for a specified axis

Parameters
    axisId Axis

See also
    setAxisMaxMinor(), QwtScaleEngine::divideScale()

Definition at line 264 of file qwt_plot_axis.cpp.

  const QwtScaleDiv & QwtPlot::axisScaleDiv (QwtAxisId axisId) const

Return the scale division of a specified axis. axisScaleDiv(axisId).lowerBound(), axisScaleDiv(axisId).upperBound() are the current limits of the axis scale.

Parameters
    axisId Axis

Returns
    Scale division

See also
    QwtScaleDiv, setAxisScaleDiv(), QwtScaleEngine::divideScale()

Definition at line 283 of file qwt_plot_axis.cpp.

  QwtScaleDraw * QwtPlot::axisScaleDraw (QwtAxisId axisId)

Return the scale draw of a specified axis.

Parameters
    axisId Axis

Returns
    Specified scaleDraw for axis, or NULL if axis is invalid.

Definition at line 308 of file qwt_plot_axis.cpp.

  const QwtScaleDraw * QwtPlot::axisScaleDraw (QwtAxisId axisId) const

Return the scale draw of a specified axis.

Parameters
    axisId Axis

Returns
    Specified scaleDraw for axis, or NULL if axis is invalid.

Definition at line 294 of file qwt_plot_axis.cpp.

  QwtScaleEngine * QwtPlot::axisScaleEngine (QwtAxisId axisId)

Parameters
    axisId Axis

Returns
    Scale engine for a specific axis

Definition at line 190 of file qwt_plot_axis.cpp.

  const QwtScaleEngine * QwtPlot::axisScaleEngine (QwtAxisId axisId) const

Parameters
    axisId Axis

Returns
    Scale engine for a specific axis

Definition at line 202 of file qwt_plot_axis.cpp.

  double QwtPlot::axisStepSize (QwtAxisId axisId) const

Return the step size parameter that has been set in setAxisScale. This doesn't need to be the step size of the current scale.

Parameters
    axisId Axis

Returns
    step size parameter value

See also
    setAxisScale(), QwtScaleEngine::divideScale()

Definition at line 326 of file qwt_plot_axis.cpp.

  QwtText QwtPlot::axisTitle (QwtAxisId axisId) const

Returns
    Title of a specified axis

Parameters
    axisId Axis

Definition at line 356 of file qwt_plot_axis.cpp.

  QwtScaleWidget * QwtPlot::axisWidget (QwtAxisId axisId)

Returns
    Scale widget of the specified axis, or NULL if axisId is invalid.

Parameters
    axisId Axis

Definition at line 153 of file qwt_plot_axis.cpp.

  const QwtScaleWidget * QwtPlot::axisWidget (QwtAxisId axisId) const

Returns
    Scale widget of the specified axis, or NULL if axisId is invalid.

Parameters
    axisId Axis

Definition at line 141 of file qwt_plot_axis.cpp.

  QWidget * QwtPlot::canvas ()

Returns
    the plot's canvas

Definition at line 463 of file qwt_plot.cpp.

  const QWidget * QwtPlot::canvas () const

Returns
    the plot's canvas

Definition at line 471 of file qwt_plot.cpp.

  QBrush QwtPlot::canvasBackground () const
Nothing else than: canvas()->palette().brush( QPalette::Normal, QPalette::Window);

Returns
    Background brush of the plotting area.

See also
    setCanvasBackground()

Definition at line 888 of file qwt_plot.cpp.

  QwtScaleMap QwtPlot::canvasMap (QwtAxisId axisId) const [virtual]

Parameters
    axisId Axis

Returns
    Map for the axis on the canvas. With this map pixel coordinates can translated to plot coordinates and vice versa.

See also
    QwtScaleMap, transform(), invTransform()

Definition at line 800 of file qwt_plot.cpp.

  void QwtPlot::drawCanvas (QPainter * painter) [virtual]
Redraw the canvas.

Parameters
    painter Painter used for drawing

Warning
    drawCanvas calls drawItems what is also used for printing. Applications that like to add individual plot items better overload drawItems()

See also
    drawItems()

Definition at line 742 of file qwt_plot.cpp.

  void QwtPlot::drawItems (QPainter * painter, const QRectF & canvasRect, const QwtScaleMap maps[QwtAxis::AxisPositions]) const [virtual]
Redraw the canvas items.

Parameters
    painter Painter used for drawing
    canvasRect Bounding rectangle where to paint
    maps QwtAxis::AxisCount maps, mapping between plot and paint device coordinates

Note
    Usually canvasRect is contentsRect() of the plot canvas. Due to a bug in Qt this rectangle might be wrong for certain frame styles ( f.e QFrame::Box ) and it might be necessary to fix the margins manually using QWidget::setContentsMargins()

Definition at line 764 of file qwt_plot.cpp.

  bool QwtPlot::event (QEvent * event) [override], [virtual]

Adds handling of layout requests.

Parameters
    event Event

Returns
    See QFrame::event()

Definition at line 237 of file qwt_plot.cpp.

  bool QwtPlot::eventFilter (QObject * object, QEvent * event) [override], [virtual]

Event filter. The plot handles the following events for the canvas:

•   QEvent::Resize The canvas margins might depend on its size

•   QEvent::ContentsRectChange The layout needs to be recalculated

Parameters
    object Object to be filtered
    event Event

Returns
    See QFrame::eventFilter()

See also
    updateCanvasMargins(), updateLayout()

Definition at line 271 of file qwt_plot.cpp.

  QwtText QwtPlot::footer () const

Returns
    Text of the footer

Definition at line 395 of file qwt_plot.cpp.

  QwtTextLabel * QwtPlot::footerLabel ()

Returns
    Footer label widget.

Definition at line 401 of file qwt_plot.cpp.

  const QwtTextLabel * QwtPlot::footerLabel () const

Returns
    Footer label widget.

Definition at line 407 of file qwt_plot.cpp.

  void QwtPlot::getCanvasMarginsHint (const QwtScaleMap maps[], const QRectF & canvasRect, double & left, double & top, double & right, double & bottom) const [virtual]

Calculate the canvas margins.

Parameters
    maps QwtAxis::AxisCount maps, mapping between plot and paint device coordinates
    canvasRect Bounding rectangle where to paint
    left Return parameter for the left margin
    top Return parameter for the top margin
    right Return parameter for the right margin
    bottom Return parameter for the bottom margin

Plot items might indicate, that they need some extra space at the borders of the canvas by the QwtPlotItem::Margins flag.

updateCanvasMargins(), QwtPlotItem::getCanvasMarginHint()

Definition at line 670 of file qwt_plot.cpp.

  QwtPlotItem * QwtPlot::infoToItem (const QVariant & itemInfo) const [virtual]

Identify the plot item according to an item info object, that has bee generated from itemToInfo(). The default implementation simply tries to unwrap a QwtPlotItem pointer:

if ( itemInfo.canConvert<QwtPlotItem *>() )
    return qvariant_cast<QwtPlotItem *>( itemInfo );

Parameters
    itemInfo Plot item

Returns
    A plot item, when successful, otherwise a NULL pointer.

See also
    itemToInfo()

Definition at line 1159 of file qwt_plot.cpp.

  void QwtPlot::insertLegend (QwtAbstractLegend * legend, QwtPlot::LegendPosition pos = QwtPlot::RightLegend, double ratio = -1.0)

Insert a legend. If the position legend is QwtPlot::LeftLegend or QwtPlot::RightLegend the legend will be organized in one column from top to down. Otherwise the legend items will be placed in a table with a best fit number of columns from left to right.

insertLegend() will set the plot widget as parent for the legend. The legend will be deleted in the destructor of the plot or when another legend is inserted.

Legends, that are not inserted into the layout of the plot widget need to connect to the legendDataChanged() signal. Calling updateLegend() initiates this signal for an initial update. When the application code wants to implement its own layout this also needs to be done for rendering plots to a document ( see QwtPlotRenderer ).

Parameters
    legend Legend
    pos The legend's position. For top/left position the number of columns will be limited to 1, otherwise it will be set to unlimited.
    ratio Ratio between legend and the bounding rectangle of title, canvas and axes. The legend will be shrunk if it would need more space than the given ratio. The ratio is limited to ]0.0 .. 1.0]. In case of <= 0.0 it will be reset to the default ratio. The default vertical/horizontal ratio is 0.33/0.5.

See also
    legend(), QwtPlotLayout::legendPosition(), QwtPlotLayout::setLegendPosition()

Definition at line 927 of file qwt_plot.cpp.

  double QwtPlot::invTransform (QwtAxisId axisId, double pos) const
Transform the x or y coordinate of a position in the drawing region into a value.

Parameters
    axisId Axis
    pos position

Returns
    Position as axis coordinate

Warning
    The position can be an x or a y coordinate, depending on the specified axis.

Definition at line 397 of file qwt_plot_axis.cpp.

  bool QwtPlot::isAxisValid (QwtAxisId axisId) const
Checks if an axis is valid

Parameters
    axisId axis

Returns
    true if the specified axis exists, otherwise false

Note
    This method is equivalent to QwtAxis::isValid( axisId ) and simply checks if axisId is one of the values of QwtAxis::Position. It is a placeholder for future releases, where it will be possible to have a customizable number of axes ( multiaxes branch ) at each side.

Definition at line 132 of file qwt_plot_axis.cpp.

  bool QwtPlot::isAxisVisible (QwtAxisId axisId) const

Returns
    True, if a specified axis is visible

Parameters
    axisId Axis

Definition at line 225 of file qwt_plot_axis.cpp.

  void QwtPlot::itemAttached (QwtPlotItem * plotItem, bool on) [signal]
A signal indicating, that an item has been attached/detached

Parameters
    plotItem Plot item
    on Attached/Detached

  QVariant QwtPlot::itemToInfo (QwtPlotItem * plotItem) const [virtual]

Build an information, that can be used to identify a plot item on the legend. The default implementation simply wraps the plot item into a QVariant object. When overloading itemToInfo() usually infoToItem() needs to reimplemeted too.

Parameters
    plotItem Plot item

Returns
    Plot item embedded in a QVariant

See also
    infoToItem()

Definition at line 1139 of file qwt_plot.cpp.

  QwtAbstractLegend * QwtPlot::legend ()

Returns
    the plot's legend

See also
    insertLegend()

Definition at line 445 of file qwt_plot.cpp.

  const QwtAbstractLegend * QwtPlot::legend () const

Returns
    the plot's legend

See also
    insertLegend()

Definition at line 454 of file qwt_plot.cpp.

  void QwtPlot::legendDataChanged (const QVariant & itemInfo, const QList< QwtLegendData > & data) [signal]
A signal with the attributes how to update the legend entries for a plot item.

Parameters
    itemInfo Info about a plot item, build from itemToInfo()
    data Attributes of the entries ( usually <= 1 ) for the plot item.

See also
    itemToInfo(), infoToItem(), QwtAbstractLegend::updateLegend()

  QwtPlotLayout * QwtPlot::plotLayout ()

Returns
    the plot's layout

Definition at line 430 of file qwt_plot.cpp.

  const QwtPlotLayout * QwtPlot::plotLayout () const

Returns
    the plot's layout

Definition at line 436 of file qwt_plot.cpp.

  void QwtPlot::replot () [virtual], [slot]

Redraw the plot. If the autoReplot option is not set (which is the default) or if any curves are attached to raw data, the plot has to be refreshed explicitly in order to make changes visible.

See also
    updateAxes(), setAutoReplot()

Definition at line 545 of file qwt_plot.cpp.

  void QwtPlot::resizeEvent (QResizeEvent * e) [override], [protected], [virtual]
Resize and update internal layout

Parameters
    e Resize event

Definition at line 530 of file qwt_plot.cpp.

  void QwtPlot::setAutoReplot (bool tf = true)

Set or reset the autoReplot option. If the autoReplot option is set, the plot will be updated implicitly by manipulating member functions. Since this may be time-consuming, it is recommended to leave this option switched off and call replot() explicitly if necessary.

The autoReplot option is set to false by default, which means that the user has to call replot() in order to make changes visible.

Parameters
    tf true or false. Defaults to true.

See also
    replot()

Definition at line 310 of file qwt_plot.cpp.

  void QwtPlot::setAxisAutoScale (QwtAxisId axisId, bool on = true)

Enable autoscaling for a specified axis. This member function is used to switch back to autoscaling mode after a fixed scale has been set. Autoscaling is enabled by default.

Parameters
    axisId Axis
    on On/Off

See also
    setAxisScale(), setAxisScaleDiv(), updateAxes()

Note
    The autoscaling flag has no effect until updateAxes() is executed ( called by replot() ).

Definition at line 449 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisFont (QwtAxisId axisId, const QFont & font)

Change the font of an axis.

Parameters
    axisId Axis
    font Font

Warning
    This function changes the font of the tick labels, not of the axis title.

Definition at line 430 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisLabelAlignment (QwtAxisId axisId, Qt::Alignment alignment)
Change the alignment of the tick labels

Parameters
    axisId Axis
    alignment Or'd Qt::AlignmentFlags see <qnamespace.h>

See also
    QwtScaleDraw::setLabelAlignment()

Definition at line 549 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisLabelRotation (QwtAxisId axisId, double rotation)
Rotate all tick labels

Parameters
    axisId Axis
    rotation Angle in degrees. When changing the label rotation, the label alignment might be adjusted too.

See also
    QwtScaleDraw::setLabelRotation(), setAxisLabelAlignment()

Definition at line 564 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisMaxMajor (QwtAxisId axisId, int maxMajor)
Set the maximum number of major scale intervals for a specified axis

Parameters
    axisId Axis
    maxMajor Maximum number of major steps

See also
    axisMaxMajor()

Definition at line 602 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisMaxMinor (QwtAxisId axisId, int maxMinor)
Set the maximum number of minor scale intervals for a specified axis

Parameters
    axisId Axis
    maxMinor Maximum number of minor steps

See also
    axisMaxMinor()

Definition at line 578 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisScale (QwtAxisId axisId, double min, double max, double stepSize = 0)

Disable autoscaling and specify a fixed scale for a selected axis. In updateAxes() the scale engine calculates a scale division from the specified parameters, that will be assigned to the scale widget. So updates of the scale widget usually happen delayed with the next replot.

Parameters
    axisId Axis
    min Minimum of the scale
    max Maximum of the scale
    stepSize Major step size. If step == 0, the step size is calculated automatically using the maxMajor setting.

See also
    setAxisMaxMajor(), setAxisAutoScale(), axisStepSize(), QwtScaleEngine::divideScale()

Definition at line 473 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisScaleDiv (QwtAxisId axisId, const QwtScaleDiv & scaleDiv)

Disable autoscaling and specify a fixed scale for a selected axis. The scale division will be stored locally only until the next call of updateAxes(). So updates of the scale widget usually happen delayed with the next replot.

Parameters
    axisId Axis
    scaleDiv Scale division

See also
    setAxisScale(), setAxisAutoScale()

Definition at line 502 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisScaleDraw (QwtAxisId axisId, QwtScaleDraw * scaleDraw)

Set a scale draw.

Parameters
    axisId Axis
    scaleDraw Object responsible for drawing scales.

By passing scaleDraw it is possible to extend QwtScaleDraw functionality and let it take place in QwtPlot. Please note that scaleDraw has to be created with new and will be deleted by the corresponding QwtScale member ( like a child object ).

See also
    QwtScaleDraw, QwtScaleWidget

Warning
    The attributes of scaleDraw will be overwritten by those of the previous QwtScaleDraw.

Definition at line 532 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisScaleEngine (QwtAxisId axisId, QwtScaleEngine * scaleEngine)
Change the scale engine for an axis

Parameters
    axisId Axis
    scaleEngine Scale engine

See also
    axisScaleEngine()

Definition at line 169 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisTitle (QwtAxisId axisId, const QString & title)

Change the title of a specified axis.

Parameters
    axisId Axis
    title axis title

Definition at line 624 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisTitle (QwtAxisId axisId, const QwtText & title)

Change the title of a specified axis.

Parameters
    axisId Axis
    title Axis title

Definition at line 636 of file qwt_plot_axis.cpp.

  void QwtPlot::setAxisVisible (QwtAxisId axisId, bool on = true)

Hide or show a specified axis. Curves, markers and other items can be attached to hidden axes, and transformation of screen coordinates into values works as normal.

Only QwtAxis::XBottom and QwtAxis::YLeft are enabled by default.

Parameters
    axisId Axis
    on true (visible) or false (hidden)

Definition at line 376 of file qwt_plot_axis.cpp.

  void QwtPlot::setCanvas (QWidget * canvas)

Set the drawing canvas of the plot widget. QwtPlot invokes methods of the canvas as meta methods ( see QMetaObject ). In opposite to using conventional C++ techniques like virtual methods they allow to use canvas implementations that are derived from QWidget or QGLWidget.

The following meta methods could be implemented:

•   replot() When the canvas doesn't offer a replot method, QwtPlot calls update() instead.

•   borderPath() The border path is necessary to clip the content of the canvas When the canvas doesn't have any special border ( f.e rounded corners ) it is o.k. not to implement this method.

The default canvas is a QwtPlotCanvas

Parameters
    canvas Canvas Widget

See also
    canvas()

Definition at line 213 of file qwt_plot.cpp.

  void QwtPlot::setCanvasBackground (const QBrush & brush)

Change the background of the plotting area. Sets brush to QPalette::Window of all color groups of the palette of the canvas. Using canvas()->setPalette() is a more powerful way to set these colors.

Parameters
    brush New background brush

See also
    canvasBackground()

Definition at line 873 of file qwt_plot.cpp.

  void QwtPlot::setFooter (const QString & text)
Change the text the footer

Parameters
    text New text of the footer

Definition at line 372 of file qwt_plot.cpp.

  void QwtPlot::setFooter (const QwtText & text)
Change the text the footer

Parameters
    text New text of the footer

Definition at line 385 of file qwt_plot.cpp.

  void QwtPlot::setPlotLayout (QwtPlotLayout * layout)

Assign a new plot layout.

Parameters
    layout Layout()

See also
    plotLayout()

Definition at line 418 of file qwt_plot.cpp.

  void QwtPlot::setTitle (const QString & title)
Change the plot's title

Parameters
    title New title

Definition at line 328 of file qwt_plot.cpp.

  void QwtPlot::setTitle (const QwtText & title)
Change the plot's title

Parameters
    title New title

Definition at line 341 of file qwt_plot.cpp.

  QSize QwtPlot::sizeHint () const [override], [virtual]

Returns
    Size hint for the plot widget

See also
    minimumSizeHint()

Definition at line 480 of file qwt_plot.cpp.

  QwtText QwtPlot::title () const

Returns
    Title of the plot

Definition at line 351 of file qwt_plot.cpp.

  QwtTextLabel * QwtPlot::titleLabel ()

Returns
    Title label widget.

Definition at line 357 of file qwt_plot.cpp.

  const QwtTextLabel * QwtPlot::titleLabel () const

Returns
    Title label widget.

Definition at line 363 of file qwt_plot.cpp.

  double QwtPlot::transform (QwtAxisId axisId, double value) const

Transform a value into a coordinate in the plotting region.

Parameters
    axisId Axis
    value value

Returns
    X or Y coordinate in the plotting region corresponding to the value.

Definition at line 414 of file qwt_plot_axis.cpp.

  void QwtPlot::updateAxes ()

Rebuild the axes scales. In case of autoscaling the boundaries of a scale are calculated from the bounding rectangles of all plot items, having the QwtPlotItem::AutoScale flag enabled ( QwtScaleEngine::autoScale() ). Then a scale division is calculated ( QwtScaleEngine::didvideScale() ) and assigned to scale widget.

When the scale boundaries have been assigned with setAxisScale() a scale division is calculated ( QwtScaleEngine::didvideScale() ) for this interval and assigned to the scale widget.

When the scale has been set explicitly by setAxisScaleDiv() the locally stored scale division gets assigned to the scale widget.

The scale widget indicates modifications by emitting a QwtScaleWidget::scaleDivChanged() signal.

updateAxes() is usually called by replot().

See also
    setAxisAutoScale(), setAxisScale(), setAxisScaleDiv(), replot() QwtPlotItem::boundingRect()

Definition at line 666 of file qwt_plot_axis.cpp.

  void QwtPlot::updateCanvasMargins ()

Update the canvas margins. Plot items might indicate, that they need some extra space at the borders of the canvas by the QwtPlotItem::Margins flag.

getCanvasMarginsHint(), QwtPlotItem::getCanvasMarginHint()

Definition at line 706 of file qwt_plot.cpp.

  void QwtPlot::updateLayout () [virtual]

Adjust plot content to its current size.

See also
    resizeEvent()

Definition at line 577 of file qwt_plot.cpp.

  void QwtPlot::updateLegend ()
Emit legendDataChanged() for all plot item

See also
    QwtPlotItem::legendData(), legendDataChanged()

Definition at line 1016 of file qwt_plot.cpp.

  void QwtPlot::updateLegend (const QwtPlotItem * plotItem)
Emit legendDataChanged() for a plot item

Parameters
    plotItem Plot item

See also
    QwtPlotItem::legendData(), legendDataChanged()

Definition at line 1032 of file qwt_plot.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.